{YourPasEdit Verson 1.04
December 4, 1997
Copyright 1997 by D C AL CODA, Ken Hale and Coda Hale
This application is codeware, given to the Delphi community in thanks for being so
helpful. You are free to make any changes to the scource. But if you do, please
send us a copy of the changed and probably improved :-) project. We will keep the
changes on our web site and they will be available as an International Internet
tutorial.

Credits: I want to thank these people expecially because they offered help with
YourPasEdit.
Martin Waldenburg: for his PAS2RTF component
Andrius Adamonis: provided the code to open a file in the running instance
Giuseppe Madaffari: help with the RichEdit component
Tim Hayes: help with the runtime creation of PageControls and TabSheets
Shiv R. Kumar: help with the runtime creation of PageControls and TabSheets
Deepak Shenoy: sharing the open and save DFM code from his FormRead application
Ray Konopka: FormFileViewer project from the Dec/Jan 1998 issue of Visual Developer Magazine


The application and code are codeware and hopefully will find a useful home in your toolkit. It
may be freely distributed, as long as all the original files are kept intact.

The code can also be freely distribute, as long as all the original files are included
and comments are left intact.

Note: You may not use this project in a commercial application, unless it comprises
only about one-half of the total project. In other words you must write 50% new code in the
new application.

It would be very nice if others wanted to add their own personal touches to the application.
This project is very much a collaborative effort. We did not write the whole code.:-)
If you do make any corrections or additions, please include all these files and comments
and add your own. And send me a copy:-) to

kenhale@dcalcoda.com

We hope to have the latest copy on my web site:

http://www.dcalcoda.com/

Disclaimer:
This is FREEWARE.  Any sale of this code is prohibited.
There is no warranty (expressed or implied) as to the workability,
merchantability, usefulness, fitness or anything else of these components.
D C AL CODA assumes no liability for damages, direct, real, imagined or
consequential, which may result from the use of this code.


We will also hopefully keep the latest copy on some of the very extensive Delphi web sites
Thank you,
Ken Hale
Coda Hale

History:
12/29/1997 := Version 1.04:	added the ability to edit Delphi Form files (DFM and ~DF)
12/14/1997 := Version 1.03: Added code in the FormCreate to add the Alt+ F4 shortcut to the File Menu
12/12/1997 := Version 1.02: Removed yet another forgotten third party component the the AboutBox Uses clause
12/05/1997 := Version 1.01: Removed a few forgotten third party components from the AboutBox
12/4/1997 := Released basic project code as Codeware;
10/11/1997 := Immediately started adding options and third-party components;
10/10/1997 := Version 1.0;  }

unit YrPasEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, mwPasToRtf, Menus, ExtCtrls, Printers;

const {Constants and variables used in the file association and running instance code}
  WM_OPENEDITOR = WM_USER + 1;
  WM_NOTEXISTS  = WM_USER + 2;
  WM_RESTOREAPP = WM_USER + 3;
  MyUniqueConst = $123554;    
var
  WM_FINDINSTANCE: Integer;
  R              : TRect;
  
type
  TPasConversionClass = class of TPasConversion;
  TfrmYourPasEdit = class(TForm)
    OpenDialog1: TOpenDialog;
    pmActivePage: TPopupMenu;
    pmaClosePage: TMenuItem;
    PageControl1: TPageControl;
    mmMainMenu: TMainMenu;
    mmSearch: TMenuItem;
    mmFind: TMenuItem;
    mmReplace: TMenuItem;
    mmFindAgain: TMenuItem;
    mmFile: TMenuItem;
    mmEdit: TMenuItem;
    mmNew: TMenuItem;
    mmOpen: TMenuItem;
    mmClose: TMenuItem;
    mmHelp: TMenuItem;
    mmAbout: TMenuItem;
    mmCut: TMenuItem;
    mmCopy: TMenuItem;
    mmPaste: TMenuItem;
    pmaFind: TMenuItem;
    N1: TMenuItem;
    pmaOpen: TMenuItem;
    pmaNew: TMenuItem;
    mmMultiLine: TMenuItem;
    pmaReplace: TMenuItem;
    mmSave: TMenuItem;
    N3: TMenuItem;
    SaveDialog1: TSaveDialog;
    mmSaveAs: TMenuItem;
    N4: TMenuItem;
    mmPrint: TMenuItem;
    mmPrinterSetup: TMenuItem;
    N5: TMenuItem;
    mmExit: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    pmaExit: TMenuItem;
    pmaCloseAllPages: TMenuItem;
    N8: TMenuItem;
    mmUndo: TMenuItem;
    mmSelectAll: TMenuItem;
    mmStatusBar: TMenuItem;
    mmView: TMenuItem;
    N9: TMenuItem;
    PrinterSetupDialog: TPrinterSetupDialog;
    PrintDialog: TPrintDialog;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    mmCloseAll: TMenuItem;
    mmSaveAll: TMenuItem;
    N2: TMenuItem;
    pmaSave: TMenuItem;
    pmaSaveAs: TMenuItem;
    pmaSaveAll: TMenuItem;
    StatusBar: TStatusBar;
    procedure mmNewClick(Sender: TObject);
    procedure mmOpenClick(Sender: TObject);
    procedure pmaClosePageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mmFindClick(Sender: TObject);
    procedure mmReplaceClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mmMultiLineClick(Sender: TObject);
    procedure mmSaveAsClick(Sender: TObject);
    procedure mmExitClick(Sender: TObject);
    procedure mmStatusBarClick(Sender: TObject);
    procedure mmEditClick(Sender: TObject);
    procedure mmSelectAllClick(Sender: TObject);
    procedure mmUndoClick(Sender: TObject);
    procedure mmCutClick(Sender: TObject);
    procedure mmCopyClick(Sender: TObject);
    procedure mmPasteClick(Sender: TObject);
    procedure mmPrintClick(Sender: TObject);
    procedure mmPrinterSetupClick(Sender: TObject);
    procedure mmAboutClick(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure mmFindAgainClick(Sender: TObject);
    procedure mmFileClick(Sender: TObject);
    procedure mmSaveClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mmCloseAllClick(Sender: TObject);
    procedure mmSaveAllClick(Sender: TObject);
    procedure NewRichEditChange(Sender: TObject);
    procedure CheckStatus(Sender: TObject);
    procedure NewRichEditSelectionChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var KEY: Word;
      Shift: TShiftState);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
  private
    { Private declarations }
    
  protected
    FFileName: string;
    procedure DefaultHandler(var message); override;
    procedure WMNotExists(var Msg: TMessage); message WM_NOTEXISTS;
    procedure WMRestoreApp(var Msg: TMessage); message WM_RESTOREAPP;
    
  public
    { Public declarations }
    Margins: TRect;
    Untitleds: Integer;
    NewRichEdit: TRichEdit;
    NewTabSheet: TTabSheet;
    PasCon: TPasConversion;
    procedure LoadFile(FName: string);
    procedure LoadFilePT(FName: string);
    procedure LoadFileDFM(FName: string);
    procedure SaveFileToDFM(Filename: string);
    procedure OpenFile(FName: string);
    procedure DisplayHint(Sender: TObject);
    procedure StartNew;
    procedure UpdateControls;
    procedure NewRichEditSetup(NewRE: TRichEdit);
    procedure CheckCapslock;
  end;
  
  
var
  frmYourPasEdit: TfrmYourPasEdit;
  
implementation

uses ClipBrd, About;

{$R *.DFM}


procedure TfrmYourPasEdit.OpenFile(FName: string);
begin {checks to see if the file is a Delphi Pascal or Project file}
  if (UpperCase(ExtractFileExt(FName)) = '.PAS') or (UpperCase(ExtractFileExt(FName)) = '.DPR')
    or (UpperCase(ExtractFileExt(FName)) = '.~DP') or (UpperCase(ExtractFileExt(FName)) = '.~PA')
    then
    LoadFile(FName) {Loads it via the PasToRtf converter}
  else {Or if it is a Delphi Form file}
    if (UpperCase(ExtractFileExt(FName)) = '.DFM') or (UpperCase(ExtractFileExt(FName)) = '.~DF')
      then
      LoadFileDFM(FName) {Loads the DFM file}
    else {otherwise load it as a plain text file}
      LoadFilePT(FName);
end;

procedure TfrmYourPasEdit.UpdateControls;
begin {Enables menu controls, based on the existence of an ActivePage,
						funny things happened if there was no ActivePage and RichEdit
           and you tried to do a Find or something}
  mmSearch.ENABLED := PageControl1.PageCount <> 0;
  mmPrint.ENABLED := PageControl1.PageCount <> 0;
  mmEdit.ENABLED := PageControl1.PageCount <> 0;
  mmClose.ENABLED := PageControl1.PageCount <> 0;
  mmCloseAll.ENABLED := PageControl1.PageCount <> 0;
  mmSave.ENABLED := PageControl1.PageCount <> 0;
  mmSaveAll.ENABLED := PageControl1.PageCount <> 0;
  mmSaveAs.ENABLED := PageControl1.PageCount <> 0;
  pmaFind.ENABLED := PageControl1.PageCount <> 0;
  pmaReplace.ENABLED := PageControl1.PageCount <> 0;
end;

procedure TfrmYourPasEdit.NewRichEditSetup(NewRE: TRichEdit);
begin {Sets NewRichEdit properties for mmNewClick and StartNew}
  with NewRE do
  begin
    Parent := NewTabSheet;
    PageRect := Margins;
    Align := alClient;
    ScrollBars := ssBoth;
    WordWrap := False;
    WantTabs := True;
    HideSelection := False;
    ShowHint := False;
    Modified := False;
    MaxLength := 1200000;
    OnChange := NewRichEditChange;
    OnSelectionChange := NewRichEditSelectionChange;
  end;
end;

procedure TfrmYourPasEdit.CheckCapslock;
begin
  {The INS/OVR is somewhat inaccurate, it will often show OVR when the mode is
       	clearly in INS mode, and show INS when the mode is clearly in OVR. If you
         figure out a way of accurately showing the state, please let us know.
         This slightly modified example comes from Marco Cantu's Mastering Delphi 3 book}

  if Odd(GetKeyState(VK_INSERT)) then
    StatusBar.Panels[3].Text := 'INS'
  else
    StatusBar.Panels[3].Text := 'OVR';
  
  if Odd(GetKeyState(VK_CAPITAL)) then
    StatusBar.Panels[4].Text := 'CAP'
  else
    StatusBar.Panels[4].Text := '';
  
  if Odd(GetKeyState(VK_NUMLOCK)) then
    StatusBar.Panels[5].Text := 'NUM'
  else
    StatusBar.Panels[5].Text := '';
end;

procedure TfrmYourPasEdit.CheckStatus(Sender: TObject);
begin
  CheckCapslock;
end;

procedure TfrmYourPasEdit.FormKeyDown(Sender: TObject; var KEY: Word;
    Shift: TShiftState);
begin
  CheckCapslock;
end;

procedure TfrmYourPasEdit.AppIdle(Sender: TObject; var Done: Boolean);
begin
  Done := True;
  CheckStatus(frmYourPasEdit);
end;
{The basic code contained in the next three procedures,
         which works with the DPR code to allow file association
         and open doubleclicked file in the running instance of app
    			was written by Andrius Adamonis}
procedure TfrmYourPasEdit.WMRestoreApp(var Msg: TMessage);
begin
  if IsIconic(Application.Handle) then
    Application.RESTORE
  else
    Application.BringToFront;
end;

procedure TfrmYourPasEdit.DefaultHandler(var message);
var
  S: string;
begin
  with TMessage(message) do
    if Msg = WM_FINDINSTANCE then
    begin
      Result := MyUniqueConst;
    end
    else if Msg = WM_OPENEDITOR then
    begin
      SetLength(S, MAX_PATH);
      GlobalGetAtomName(WPARAM, PChar(S), MAX_PATH);
      SetLength(S, StrLen(PChar(S)));
      try
        OpenFile(S);
        except on E: Exception do
            raise Exception.Create('Error opening ' + S + ' - ' + E.message);
      end;
    end
    else inherited DefaultHandler(message);
end;


procedure TfrmYourPasEdit.WMNotExists(var Msg: TMessage);
begin
  MessageDlg(Format('File ''%s'' does not exist',[FFileName]), mtError,[mbOK], 0);
end;

procedure TfrmYourPasEdit.LoadFile(FName: string);
begin {Creates a new TabSheet and RichEdit}
  if FileExists(FName) then
  begin
    SCREEN.Cursor := crHourGlass;
    try
      NewTabSheet := TTabSheet.Create(PageControl1);
      NewTabSheet.CAPTION := ExtractFileName(FName);
      NewTabSheet.Hint := FName;
      NewTabSheet.ShowHint := False;
      NewTabSheet.Tag := 1;
      NewTabSheet.PageControl := PageControl1;
      PageControl1.ActivePage := NewTabSheet;
      PageControl1.ActivePage.PopupMenu := pmActivePage;
      PageControl1.ShowHint := False;
      NewRichEdit := TRichEdit.Create(NewTabSheet);
      with NewRichEdit do
      begin
        Parent := NewTabSheet;
        Align := alClient;
        ScrollBars := ssBoth;
        WordWrap := False;
        WantTabs := True;
        HideSelection := False;
        ShowHint := False;
        SetFocus;
      end;
      {sends file through the PasToRtf conversion unit}
      {if a Delphi file, containing too much uncommented text is opened,
                an Invalid String error occurs}
      PasCon := TPasConversion.Create;
      PasCon.UseDelphiHighlighting(3);
      PasCon.LOADFROMFILE(FName);
      PasCon.ConvertReadStream;
      NewRichEdit.Lines.BeginUpdate;
      NewRichEdit.Lines.LoadFromStream(PasCon);
      NewRichEdit.Lines.EndUpdate;
      NewRichEdit.Modified := False;
      NewRichEdit.OnChange := NewRichEditChange;
      NewRichEdit.OnSelectionChange := NewRichEditSelectionChange;
      ActiveControl := NewRichEdit;
      PasCon.Free;
      UpdateControls;
    finally
      SCREEN.Cursor := crDefault;
      SetForegroundWindow(Handle);
    end
  end
  else
  begin
    SetForegroundWindow(Handle);
    PostMessage(Handle, WM_NOTEXISTS, 0, 0);
  end;
end;

procedure TfrmYourPasEdit.LoadFilePT(FName: string);
begin {Loads the file as plain text, used so plain text files can be loaded
					without going through the PasToRtf unit}
  if FileExists(FName) then
  begin
    SCREEN.Cursor := crHourGlass;
    try
      NewTabSheet := TTabSheet.Create(PageControl1);
      NewTabSheet.CAPTION := ExtractFileName(FName);
      NewTabSheet.Hint := FName;
      NewTabSheet.ShowHint := False;
      NewTabSheet.Tag := 0;
      NewTabSheet.PageControl := PageControl1;
      PageControl1.ActivePage := NewTabSheet;
      PageControl1.ActivePage.PopupMenu := pmActivePage;
      PageControl1.ShowHint := False;
      NewRichEdit := TRichEdit.Create(NewTabSheet);
      with NewRichEdit do
      begin
        Parent := NewTabSheet;
        Align := alClient;
        ScrollBars := ssBoth;
        WordWrap := False;
        WantTabs := True;
        ShowHint := False;
        HideSelection := False;
        Lines.LOADFROMFILE(FName);
        Modified := False;
        OnChange := NewRichEditChange;
        OnSelectionChange := NewRichEditSelectionChange;
      end;
      ActiveControl := NewRichEdit;
      NewRichEdit.Modified := False;
      UpdateControls;
    finally
      SCREEN.Cursor := crDefault;
      SetForegroundWindow(Handle);
    end
  end
  else
  begin
    SetForegroundWindow(Handle);
    PostMessage(Handle, WM_NOTEXISTS, 0, 0);
  end;
end;

procedure TfrmYourPasEdit.LoadFileDFM(FName: string);
var
  InStream, OutStream: TMemoryStream;
begin {This uses Delphi's built in ObjectResourceToText procedure to
												convert the Delphi Form file to a plain text format and then opens
                       the file in a new TabSheet/RichEdit}
  if FileExists(FName) then
  begin
    SCREEN.Cursor := crHourGlass;
    try
      NewTabSheet := TTabSheet.Create(PageControl1);
      NewTabSheet.CAPTION := ExtractFileName(FName);
      NewTabSheet.Hint := FName;
      NewTabSheet.ShowHint := False;
      NewTabSheet.Tag := 1;
      NewTabSheet.PageControl := PageControl1;
      PageControl1.ActivePage := NewTabSheet;
      PageControl1.ActivePage.PopupMenu := pmActivePage;
      PageControl1.ShowHint := False;
      NewRichEdit := TRichEdit.Create(NewTabSheet);
      with NewRichEdit do
      begin
        Parent := NewTabSheet;
        Align := alClient;
        ScrollBars := ssBoth;
        WordWrap := False;
        WantTabs := True;
        HideSelection := False;
        ShowHint := False;
        SetFocus;
      end;
      try
        InStream := TMemoryStream.Create;
        InStream.LOADFROMFILE(FName);
        OutStream := TMemoryStream.Create;
        ObjectResourceToText(InStream, OutStream);
        OutStream.Seek(0, 0);
        NewRichEdit.Lines.LoadFromStream(OutStream);
        InStream.Free;
        OutStream.Free;
        except on E: Exception do
            MessageDlg('An error occured during syntax highlighting: ' + E.message + #13 + #10 + #13 + #10 +
            'This usually means that the Delphi file you are' + #13 + #10 +
            ' attempting to open is not a valid Form File (DFM).', mtError,[mbOK], 55);
      end;
      NewRichEdit.Modified := False;
      NewRichEdit.OnChange := NewRichEditChange;
      NewRichEdit.OnSelectionChange := NewRichEditSelectionChange;
      ActiveControl := NewRichEdit;
      UpdateControls;
    finally
      SCREEN.Cursor := crDefault;
      SetForegroundWindow(Handle);
    end
  end
  else
  begin
    SetForegroundWindow(Handle);
    PostMessage(Handle, WM_NOTEXISTS, 0, 0);
  end;
end;

procedure TfrmYourPasEdit.SaveFileToDFM(Filename: string);
var
  OutStream: TFileStream;  
  InStream : TMemoryStream;
  Plaintext: Boolean;      
begin {This uses Delphi's built in ObjectTextToResource procedure to convert the plain text
									file to the Delphi Form file format}
  OutStream := TFileStream.Create(Filename, fmCreate or fmOpenReadWrite);
  InStream := TMemoryStream.Create;
  Plaintext := TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext;
  TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext := True;
  TRichEdit(PageControl1.ActivePage.Controls[0]).Lines.SaveToStream(InStream);
  TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext := Plaintext;
  InStream.Seek(0, 0);
  ObjectTextToResource(InStream, OutStream); //ObjectTextToResource(TMemoryStream, TFileStream);
  OutStream.Free;
  InStream.Free;
end;

procedure TfrmYourPasEdit.StartNew;
begin {This procedure is not useful in this example app.
						It will be used in a fancy version to allow the option,
           mmStartNew, of starting with a New RichEdit or not
           and is left here because the code works and provides
           the basis for an option if you want to add it.}
  {Create the NewTabSheet}
  NewTabSheet := TTabSheet.Create(PageControl1);
  {Set the NewTabSheet Properties}
  NewTabSheet.CAPTION := 'untitled';
  NewTabSheet.PageControl := PageControl1;
  PageControl1.ActivePage := NewTabSheet;
  PageControl1.ActivePage.PopupMenu := pmActivePage;
  PageControl1.ShowHint := False;
  {creates a NewRichEdit and setsthe NewTabSheet as the parent}
  NewRichEdit := TRichEdit.Create(NewTabSheet);
  NewRichEditSetup(NewRichEdit);
  ActiveControl := NewRichEdit;
  UpdateControls;
end;


procedure TfrmYourPasEdit.FormCreate(Sender: TObject);
begin
  {This had to be done because D3 refused to assign my choice of Application Icon
   		reverting the the old gray default Dellphi icon.}
  Application.ICON := ICON;
  UpdateControls; {Updates MenuItems based on the existance of a TabSheet/RichEdit}
  Application.OnHint := DisplayHint; {Displays hint in the StatusBar}
  Application.OnIdle := AppIdle;
  mmExit.Shortcut := Shortcut(VK_F4,[ssAlt]); //This puts Alt F4 on the menu
end;

procedure TfrmYourPasEdit.FormShow(Sender: TObject);
begin {This is used in the Start With New option}
  mmNewClick(Sender);
  if Assigned(NewRichEdit) then NewRichEdit.SetFocus;
end;

procedure TfrmYourPasEdit.FormDestroy(Sender: TObject);
begin
  SCREEN.OnActiveFormChange := nil;
end;

procedure TfrmYourPasEdit.mmNewClick(Sender: TObject);
begin {This will be used with the Start With New option}
  Inc(Untitleds);
  {Create the NewTabSheet}
  NewTabSheet := TTabSheet.Create(PageControl1);
  {Set the NewTabSheet Properties}
  NewTabSheet.CAPTION := 'untitled' + IntToStr(Untitleds);
  NewTabSheet.Hint := 'untitled' + IntToStr(Untitleds);
  //Sets the Hint to the FileName, which then appears in the StatusBar
  NewTabSheet.PageControl := PageControl1;
  PageControl1.ActivePage := NewTabSheet;
  PageControl1.ActivePage.PopupMenu := pmActivePage;
  PageControl1.ShowHint := False;
  {creates a NewRichEdit and setsthe NewTabSheet as the parent}
  NewRichEdit := TRichEdit.Create(NewTabSheet);
  {Set the NewRichEdit Properties}
  NewRichEditSetup(NewRichEdit);
  ActiveControl := NewRichEdit;
  NewRichEdit.Modified := False;
  UpdateControls;
end;

procedure TfrmYourPasEdit.mmOpenClick(Sender: TObject);
begin {File Open procedure}
  try
    if OpenDialog1.Execute then
    begin
      OpenFile(OpenDialog1.Filename);
    end;
    UpdateControls;
    except on E: Exception do
        raise Exception.Create('Error opening ' + OpenDialog1.Filename + ' - ' + E.message);
  end;
end;

procedure TfrmYourPasEdit.pmaClosePageClick(Sender: TObject);
begin {Close the active page}
  if TRichEdit(PageControl1.ActivePage.Controls[0]).Modified then
  begin
    case MessageDlg('File: ' +
      PageControl1.ActivePage.CAPTION +
        ', has changed. Save now?', mtConfirmation,
        mbYesNoCancel, 0) of
        IDYES:
        begin
          mmSaveClick(Sender);
          PageControl1.ActivePage.Free; //Closes and Frees the ActivePage
          PageControl1.SelectNextPage(False);
          UpdateControls;
        end;
      IDNO:
      begin
        PageControl1.ActivePage.Free; //Closes and Frees the ActivePage
        PageControl1.SelectNextPage(False);
        UpdateControls;
      end;
    end;
  end else
  begin
    PageControl1.ActivePage.Free; //Closes and Frees the ActivePage
    PageControl1.SelectNextPage(False);
    UpdateControls;
  end;

end;

procedure TfrmYourPasEdit.mmFindClick(Sender: TObject);
begin
  with TRichEdit(PageControl1.ActivePage.Controls[0]) do
  begin
    if (SelLength > 0) and (SelLength < 30) then
      FindDialog1.FindText := SelText;
    FindDialog1.Execute;
  end;
end;
{I think this came from a Neil Rubenking example}
procedure TfrmYourPasEdit.FindDialog1Find(Sender: TObject);
const STypes: array[Boolean, Boolean] of TSearchTypes =
  (([],[stMatchCase]),
    ([stWholeWord],[stWholeWord, stMatchCase]));
var Start, len, loc: Integer;
begin
  Start := TRichEdit(PageControl1.ActivePage.Controls[0]).SelStart + TRichEdit(PageControl1.ActivePage.Controls[0]).SelLength;
  len := TRichEdit(PageControl1.ActivePage.Controls[0]).GetTextLen - Start;
  with Sender as TFindDialog do
    loc := TRichEdit(PageControl1.ActivePage.Controls[0]).FindText(FindText, Start, len,
    STypes[frWholeWord in Options, frMatchCase in Options]);
  if loc = -1 then
    MessageBeep(MB_ICONSTOP)
    {I would like to have a message popup saying that no other instances of the
       chosen word was found, but it seems to cause some
       functions to fail, like ReplaceAll}
  else
  begin
    TRichEdit(PageControl1.ActivePage.Controls[0]).SelStart := loc;
    TRichEdit(PageControl1.ActivePage.Controls[0]).SelLength :=
      Length((Sender as TFindDialog).FindText);
  end;
  FindDialog1.FindText := (Sender as TFindDialog).FindText;
  ReplaceDialog1.FindText := FindDialog1.FindText;
end;

procedure TfrmYourPasEdit.mmFindAgainClick(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
    FindDialog1Find(FindDialog1);
end;

procedure TfrmYourPasEdit.mmReplaceClick(Sender: TObject);
begin
  with TRichEdit(PageControl1.ActivePage.Controls[0]) do
  begin
    if (SelLength > 0) and (SelLength < 30) then
      ReplaceDialog1.FindText := SelText;
    ReplaceDialog1.Execute;
  end;
end;

procedure TfrmYourPasEdit.ReplaceDialog1Replace(Sender: TObject);
begin
  ENABLED := False;
  SCREEN.Cursor := crHourGlass;
  TRichEdit(PageControl1.ActivePage.Controls[0]).Perform(WM_SETREDRAW, 0, 0);
  try
    with Sender as TReplaceDialog do
      while True do
      begin
        if TRichEdit(PageControl1.ActivePage.Controls[0]).SelText <> FindText then
          FindDialog1Find(Sender);
        if TRichEdit(PageControl1.ActivePage.Controls[0]).SelLength = 0 then Break;
        TRichEdit(PageControl1.ActivePage.Controls[0]).SelText := ReplaceText;
        if not (frReplaceAll in Options) then Break;
        Application.ProcessMessages;
        if Application.Terminated then Break;
      end;
  finally
    ENABLED := True;
    SCREEN.Cursor := crDefault;
    TRichEdit(PageControl1.ActivePage.Controls[0]).Perform(WM_SETREDRAW, 1, 0);
    TRichEdit(PageControl1.ActivePage.Controls[0]).Refresh;
  end;
end;
{OPTIONS}
procedure TfrmYourPasEdit.mmMultiLineClick(Sender: TObject);
begin {display the TabSheets in a MultiLine}
  mmMultiLine.checked := not mmMultiLine.checked;
  if mmMultiLine.checked then
    PageControl1.MultiLine := True
  else
    PageControl1.MultiLine := False;
end;

procedure TfrmYourPasEdit.mmStatusBarClick(Sender: TObject);
begin {Toggle StatusBar visible}
  mmStatusBar.checked := not mmStatusBar.checked;
  StatusBar.Visible := mmStatusBar.checked;
end;

procedure TfrmYourPasEdit.DisplayHint(Sender: TObject);
begin {This also displays the file path when the cursor is in the RichEdit}
  StatusBar.Panels[6].Text := Application.Hint;
end;

procedure TfrmYourPasEdit.mmExitClick(Sender: TObject);
begin
  CLOSE; {Hmm, I wonder what this does?:-}
end;

procedure TfrmYourPasEdit.mmEditClick(Sender: TObject);
begin {Enables Edits commands according to availability of a selected item}
  if Assigned(PageControl1.ActivePage) then
    TRichEdit(PageControl1.ActivePage.Controls[0]).SetFocus else Exit;
  mmPaste.ENABLED := Clipboard.HasFormat(CF_TEXT);
  mmUndo.ENABLED := TRichEdit(PageControl1.ActivePage.Controls[0]).Perform(EM_CANUNDO, 0, 0) <> 0;
  mmCut.ENABLED := TRichEdit(PageControl1.ActivePage.Controls[0]).SelLength > 0;
  mmCopy.ENABLED := TRichEdit(PageControl1.ActivePage.Controls[0]).SelLength > 0;
  mmFindAgain.ENABLED := FindDialog1.FindText <> '';
end;
{These are the Edit MenuItems}
procedure TfrmYourPasEdit.mmSelectAllClick(Sender: TObject);
begin
  TRichEdit(PageControl1.ActivePage.Controls[0]).SelectAll;
end;

procedure TfrmYourPasEdit.mmUndoClick(Sender: TObject);
begin
  TRichEdit(PageControl1.ActivePage.Controls[0]).Perform(EM_UNDO, 0, 0);
end;

procedure TfrmYourPasEdit.mmCutClick(Sender: TObject);
begin
  TRichEdit(PageControl1.ActivePage.Controls[0]).CutToClipboard;
end;

procedure TfrmYourPasEdit.mmCopyClick(Sender: TObject);
begin
  TRichEdit(PageControl1.ActivePage.Controls[0]).CopyToClipboard;
end;

procedure TfrmYourPasEdit.mmPasteClick(Sender: TObject);
begin
  TRichEdit(PageControl1.ActivePage.Controls[0]).PasteFromClipboard;
end;

procedure TfrmYourPasEdit.mmPrintClick(Sender: TObject);
begin {Performs the basic RichEdit printing}
  if Assigned(NewRichEdit) then
    with PrintDialog do
      if Execute then
      begin
        NewRichEdit.Print(SaveDialog1.Filename);
      end
      else
        Exit;
end;

procedure TfrmYourPasEdit.mmPrinterSetupClick(Sender: TObject);
begin {Opens the Printer Setup dialog}
  with PrinterSetupDialog do Execute;
end;

procedure TfrmYourPasEdit.mmAboutClick(Sender: TObject);
begin {Shows the AboutBox}
  Application.CreateForm(TfrmAbout, frmAbout);
  frmAbout.ShowModal;
  frmAbout.Release;
end;

procedure TfrmYourPasEdit.mmFileClick(Sender: TObject);
begin {Enables the Save MenuItem if RichEdit is Modified}
  mmSave.ENABLED := (Assigned(PageControl1.ActivePage)) and (TRichEdit(PageControl1.ActivePage.Controls[0]).Modified);
end;

procedure TfrmYourPasEdit.mmSaveClick(Sender: TObject);
var {Saves the file based on which file extension is selected}
  Plaintext: Boolean;
begin
  if not FileExists(PageControl1.ActivePage.Hint) then
    mmSaveAsClick(Sender) else
  begin {if it is NOT a Delphi Form file}
    if (UpperCase(ExtractFileExt(PageControl1.ActivePage.Hint)) <> '.DFM') and
      (UpperCase(ExtractFileExt(PageControl1.ActivePage.Hint)) <> '.~DF') then
    begin {it gets saved as a plain text file}
      Plaintext := TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext;
      TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext := (UpperCase(ExtractFileExt(PageControl1.ActivePage.Hint)) <> '.RTF');
      TRichEdit(PageControl1.ActivePage.Controls[0]).Lines.SaveToFile(PageControl1.ActivePage.Hint);
      TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext := Plaintext;
      TRichEdit(PageControl1.ActivePage.Controls[0]).Modified := False;
      PageControl1.ActivePage.CAPTION := ExtractFileName(PageControl1.ActivePage.Hint);
    end else
    begin {if it is a DFM or ~DF file, it gets saved as a DFM}
      SaveFileToDFM(PageControl1.ActivePage.Hint);
      TRichEdit(PageControl1.ActivePage.Controls[0]).Modified := False;
      PageControl1.ActivePage.CAPTION := ExtractFileName(PageControl1.ActivePage.Hint);
    end;
  end;
end;

procedure TfrmYourPasEdit.mmSaveAsClick(Sender: TObject);
var
  Plaintext: Boolean;
begin
  if SaveDialog1.Execute then
  begin
    if (UpperCase(ExtractFileExt(PageControl1.ActivePage.Hint)) <> '.DFM') and
      (UpperCase(ExtractFileExt(PageControl1.ActivePage.Hint)) <> '.~DF') then
    begin
      Plaintext := TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext;
      TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext := SaveDialog1.FilterIndex <> 2;
      TRichEdit(PageControl1.ActivePage.Controls[0]).Lines.SaveToFile(SaveDialog1.Filename);
      TRichEdit(PageControl1.ActivePage.Controls[0]).Plaintext := Plaintext;
      PageControl1.ActivePage.CAPTION := ExtractFileName(SaveDialog1.Filename);
      PageControl1.ActivePage.Hint := SaveDialog1.Filename;
      TRichEdit(PageControl1.ActivePage.Controls[0]).Modified := False;
    end else
    begin
      SaveFileToDFM(SaveDialog1.Filename);
      PageControl1.ActivePage.CAPTION := ExtractFileName(SaveDialog1.Filename);
      PageControl1.ActivePage.Hint := SaveDialog1.Filename;
      TRichEdit(PageControl1.ActivePage.Controls[0]).Modified := False;
    end;
  end;
end;

procedure TfrmYourPasEdit.FormCloseQuery(Sender: TObject;
    var CanClose: Boolean);
var {Checks if RichEdit has been Modified before closing}
  I: Integer;
begin
  for I := 0 to PageControl1.PageCount - 1 do
  begin
    if TRichEdit(PageControl1.Pages[I].Controls[0]).Modified then
      
      case MessageDlg('File: ' +
        PageControl1.Pages[I].CAPTION +
          ', has changed. Save now?', mtConfirmation,
          mbYesNoCancel, 0) of
          IDYES: mmSaveClick(Sender);
          IDNO:;
          IDCANCEL: CanClose := False;
        end;
      end;
  end;

procedure TfrmYourPasEdit.mmCloseAllClick(Sender: TObject);
var {Close All pages}
  I: Integer;
begin
  for I := PageControl1.PageCount - 1 downto 0 do
  begin
    PageControl1.ActivePage := PageControl1.Pages[I];
    pmaClosePageClick(Sender);
  end;
end;

procedure TfrmYourPasEdit.mmSaveAllClick(Sender: TObject);
var {Save All modified RichEdits}
  I: Integer;
begin
  for I := PageControl1.PageCount - 1 downto 0 do
  begin
    PageControl1.ActivePage := PageControl1.Pages[I];
    mmSaveClick(Sender);
  end;
end;

procedure TfrmYourPasEdit.NewRichEditChange(Sender: TObject);
begin {Places an asterisk on TabSheet's tab which contains a Modified RichEdit}
  if Assigned(PageControl1.ActivePage) and
    (TRichEdit(PageControl1.ActivePage.Controls[0]).Modified) and
    not (PageControl1.ActivePage.CAPTION[Length(PageControl1.ActivePage.CAPTION)] = '*') then
    PageControl1.ActivePage.CAPTION := PageControl1.ActivePage.CAPTION + '*';
end; //This is where Closing pages causes the Access Violation

procedure TfrmYourPasEdit.NewRichEditSelectionChange(Sender: TObject);
var {A Neil Rubenking example of putting the cursor position into the StatusBar}
  RO, CO: Integer;
begin
  
  with Sender as TCustomEdit do
  begin
    RO := Perform(EM_LINEFROMCHAR, SelStart, 0);
    CO := SelStart - Perform(EM_LINEINDEX, RO, 0);
    StatusBar.Panels[0].Text := FormatFloat('0,', RO + 1);
    StatusBar.Panels[1].Text := FormatFloat('0,', CO + 1);
    StatusBar.Panels[2].Text := FormatFloat(',0', SelStart);
  end;
end;

initialization {Used in the file association and running instance code}
  WM_FINDINSTANCE := RegisterWindowMessage('Editor: find previous instance');
  if WM_FINDINSTANCE = 0 then raise Exception.Create('Initialization failed');
  
end.

